unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DDEReports, XLS4Reports, ReportContainer, Db, DBTables,
  ComCtrls, COMReports, SylkReports, DDEClient, CommonType, ShellApi,
  WordReports;

type
  TForm1 = class(TForm)
    ReportContainer1: TReportContainer;
    XLS4Report1: TXLS4Report;
    Button1: TButton;
    oDB: TTable;
    pb: TProgressBar;
    Button2: TButton;
    ExcelCOMReport1: TExcelCOMReport;
    ExcelDDEReport1: TExcelDDEReport;
    SylkReport1: TSylkReport;
    Button3: TButton;
    Button4: TButton;
    DdeMgrClient1: TDdeMgrClient;
    WordReport1: TWordReport;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ReportContainer1MoveNext(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer1MoveTop(Sender: TObject;
      var bCheck: Boolean);
    procedure ReportContainer1ReportError(Sender: TObject; mError,
      nError: Cardinal; sError: String);
    procedure ReportContainer1DataRequest(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var sData: Variant;
      var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ReportContainer1RequestByName(Sender: TObject;
      sSectionName: String; var sFieldName, sStr: String);
    procedure ReportContainer1StartReport(Sender: TObject);
    procedure ReportContainer1EndReport(Sender: TObject);
    procedure ReportContainer1SectionCheck(Sender: TObject;
      SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
    procedure ReportContainer1SectionEnd(Sender: TObject;
      SectionName: String; SectionNum: Cardinal);
    procedure ReportContainer1RequestByNum(Sender: TObject;
      sSectionName: String; var iP: Integer; var sStr: String);
    procedure Button5Click(Sender: TObject);
    procedure ReportContainer1SectionPrepare(Sender: TObject);
  private
    { Private declarations }
    t: TDateTime;
    OldGroup: String;
    s1, s2: double;
    OutputBlank: String;
    SOMTHING: Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReportContainer1.Report := XLS4Report1;
  OutputBlank := XLS4Report1.OutputBlank;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ReportContainer1.Report := ExcelCOMReport1;
  OutputBlank := ExcelCOMReport1.OutputBlank;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ReportContainer1.Report := ExcelDDEReport1;
  OutputBlank := ExcelDDEReport1.OutputBlank;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReportContainer1.Report := SylkReport1;
  OutputBlank := SylkReport1.OutputBlank;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ReportContainer1.Report := WordReport1;
  OutputBlank := WordReport1.OutputBlank;
  ReportContainer1.ReportExecute;
end;

procedure TForm1.ReportContainer1MoveNext(Sender: TObject;
  var bCheck: Boolean);
begin
  oDB.Next;
  if (oDB.RecNo mod 10) = 0 then
    ReportContainer1.OutSection('SOMTHING');
  pb.Position := pb.Position + 1;
  bCheck := oDB.Eof;
end;

procedure TForm1.ReportContainer1MoveTop(Sender: TObject;
  var bCheck: Boolean);
begin

  //
  pb.Min := 1;
  pb.Max := oDB.RecordCount;
  pb.Position := 1;
  //

  oDB.First;
  bCheck := oDB.Eof;

end;

procedure TForm1.ReportContainer1ReportError(Sender: TObject; mError,
  nError: Cardinal; sError: String);
begin
  ShowMessage(sError);
end;

procedure TForm1.ReportContainer1DataRequest(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var sData: Variant;
  var bCheck: Boolean; OutR, OutC, InR, InC: Cardinal);
begin
  if SectionNum = REPORT_HEADER then begin
    bCheck := false;
  end;
  if SectionNum = GROUP_HEADER then begin
    if VarType(sData) in [varSmallint, varInteger, varSingle, varDouble, varCurrency] then begin
      if sData = 1 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('State').AsString;
        bCheck := true;
        Exit;
      end;
    end;
  end;
  if SectionNum = BODY then begin
    if VarType(sData) in [varSmallint, varInteger, varSingle, varDouble, varCurrency] then begin
      if sData = 1 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('First').AsString;
        bCheck := true;
        Exit;
      end;
      if sData = 3 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('City').AsString;
        bCheck := true;
        Exit;
      end;
      if sData = 5 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('ZIP').AsString;
        bCheck := true;
        Exit;
      end;
      if sData = 6 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('Age').AsInteger;
        bCheck := true;
        Exit;
      end;
      if sData = 7 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('Salary').AsFloat;
        bCheck := true;
        Exit;
      end;
    end;
  end;
  if SectionNum = GROUP_FOOTER then begin
    if VarType(sData) in [varSmallint, varInteger, varSingle, varDouble, varCurrency] then begin
      if sData = 1 then begin
        sData := Unassigned;
        sData := oDB.FieldByName('State').AsString;
        bCheck := true;
        Exit;
      end;
      if sData = 2 then begin
        sData := Unassigned;
        sData := s1;
        s2 := s2 + s1;
        s1 := 0;
        bCheck := true;
        Exit;
      end;
    end;
  end;
  if SectionNum = REPORT_FOOTER then begin
    if VarType(sData) in [varSmallint, varInteger, varSingle, varDouble, varCurrency] then begin
      if sData = 1 then begin
        sData := Unassigned;
        sData := s2;
        bCheck := true;
        Exit;
      end;
    end;
  end;
end;

procedure TForm1.ReportContainer1RequestByName(Sender: TObject;
  sSectionName: String; var sFieldName, sStr: String);
begin
  if Integer(ReportContainer1.CurrentSectionNum) = SOMTHING then begin
      if sFieldName = 'SOMTHING' then begin
        sStr := IntToStr(oDB.RecNo);
        Exit;
      end;
  end;
  if sSectionName = 'BODY' then begin
    sStr := oDB.FieldByName(sFieldName).AsString;
  end;
end;

procedure TForm1.ReportContainer1StartReport(Sender: TObject);
begin
  t:= Now;
  s1 := 0;
  s2 := 0;
end;

procedure TForm1.ReportContainer1EndReport(Sender: TObject);
var
  d: TDateTime;
  ts: TTimeStamp;
  m, c, mc: Integer;
begin
  d := Now - t;
  ts := DateTimeToTimeStamp(d);
  m := ts.Time div (1000 * 60);
  c := (ts.Time - m * (1000 * 60)) div 1000;
  mc := ts.Time - m * (1000 * 60) - c * 1000;
  ShowMessage(Format('%d:%d:%d', [m, c, mc]));
  ShellExecute(self.Handle, Pchar('open'), pChar(OutputBlank), Pchar('/n'), nil, SW_SHOWNORMAL);
end;

procedure TForm1.ReportContainer1SectionCheck(Sender: TObject;
  SectionName: String; SectionNum: Cardinal; var bCheck: Boolean);
begin
  case SectionNum of
    GROUP_HEADER:
      begin
        oDB.Prior;
        if not oDB.Bof then begin
            OldGroup :=  Trim(oDB.Fields[4].AsString);  //#STATE
            oDB.Next;
        end else
            OldGroup := 'hhhhhhhhhhhhhhhhhhhhhhh';
        if OldGroup <> Trim(oDB.Fields[4].AsString) then bCheck := true;
      end;
    GROUP_FOOTER:
      begin
        oDB.Next;
        if not oDB.Eof then begin
          OldGroup := Trim(oDB.Fields[4].AsString);  //#STATE
          oDB.Prior;
        end else OldGroup := 'chfdhhtryrye';
        if OldGroup <> Trim(oDB.Fields[4].AsString) then bCheck := true;
      end;
  end;
end;

procedure TForm1.ReportContainer1SectionEnd(Sender: TObject;
  SectionName: String; SectionNum: Cardinal);
begin
  if SectionNum = BODY then
    s1 := s1 + oDB.FieldByName('SALARY').AsFloat;
end;

procedure TForm1.ReportContainer1RequestByNum(Sender: TObject;
  sSectionName: String; var iP: Integer; var sStr: String);
var
  bCheck: boolean;
  sData: Variant;
begin
  if ReportContainer1.CurrentSectionNum = REPORT_HEADER then begin
    if iP = 1 then
      sStr := 'First parameter';
    if iP = 2 then
      sStr := 'Second parameter';
  end else begin
    bCheck := false;
    sData := iP;
    ReportContainer1DataRequest(self, sSectionName, ReportContainer1.CurrentSectionNum,
      sData, bCheck, 0, 0, 0, 0);
    if bCheck then begin
      sStr := VarToStr(sData);
    end;
  end;
end;

procedure TForm1.ReportContainer1SectionPrepare(Sender: TObject);
begin
  SOMTHING := ReportContainer1.PrepareSection('SOMTHING');
end;

end.

